- name: "Installing lvm2"
  dnf:
    name: "lvm2"
    state: "present"

- name: "Update volumes to volumes add, with default values for vgname,lvname and fs_type (ext4) if not set"
  set_fact:
    volumes_add: "{{ volumes_add | default([]) + [{'device' : item.device
    , 'vgname': item.vgname| default(item.mount_point | regex_replace('^.*/([^/]+$)','vg_\\1'))
    , 'lvname': item.lvname| default(item.mount_point | regex_replace('^.*/([^/]+$)','lv_\\1'))
    , 'mount_point': item.mount_point
    , 'fs_type': item.fs_type| default('xfs')
    , 'keep_files' : item.keep_files | default (false)
    , 'opts': item.opts | default('defaults') }] }}"
  with_items: "{{ volumes }}"

- name: "Create new volume groups"
  lvg:
    vg: "{{ item.vgname }}"
    pvs: "{{ item.device }}"
    state: "present"
  with_items: "{{ volumes_add }}"
  register: "volume_group"
  when: "not skip_vg_create | default (false) | bool"

- name: "Creating new logical volumes"
  lvol:
    vg: "{{ item.vgname }}"
    lv: "{{ item.lvname }}"
    size: "100%FREE"
    shrink: "no"
  with_items: "{{ volumes_add }}"

- name: "Creating new filesystems on new volumes"
  filesystem:
    fstype: "{{ item.fs_type }}"
    dev: "/dev/{{ item.vgname }}/{{ item.lvname }}"
  with_items: "{{ volumes_add }}"
  when: "volume_group.changed | bool"

- name: "Create mount points"
  file:
    path: "{{ item.mount_point }}"
    state: "directory"
  with_items: "{{ volumes_add }}"

- name: "Mounting new filesystems"
  mount:
    name: "{{ item.mount_point }}"
    src: "/dev/{{ item.vgname }}/{{ item.lvname }}"
    fstype: "{{ item.fs_type }}"
    state: "mounted"
    opts: "{{ item.opts | default('defaults') }}"
  with_items: "{{ volumes_add }}"

- name: "check if new file system has content"
  find:
    paths: "{{ item.mount_point }}"
    recurse: yes
  loop: "{{ volumes_add }}"
  when: "item.keep_files | bool"
  register: "keep_files"

- name: "include volume sync from mount point if 'keep_volumes' is set and  dir is empty"
  include_tasks: "keep_volume_files.yml"
  when: "keep_files.results[0].files is defined and keep_files.results[0].files | count == 0"

